// win32Dll.cpp : Defines the entry point for the DLL application.
//

#include "stdafx.h"
#include "win32Dll.h"
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>


HINSTANCE  g_myHnd         = 0 ;
HWND       g_hwndEditCtrl  = 0 ;
int        g_retValue      = 0 ;

// Function prototype for our Dialog plugin
BOOL CALLBACK MyProc(HWND,UINT,WPARAM,LPARAM);

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{

    switch (ul_reason_for_call)
	{
		case DLL_PROCESS_ATTACH:
		case DLL_THREAD_ATTACH:
		case DLL_THREAD_DETACH:
		case DLL_PROCESS_DETACH:
			break;
    }
	
	//DLL instance MUST be used to load embedded resources.
	g_myHnd = (HINSTANCE)hModule;

    return TRUE;
}


__stdcall int GUIConfirmPID(int pid)
{
	
	g_retValue = pid ;

	DialogBox(g_myHnd,MAKEINTRESOURCE(101),0,(DLGPROC)MyProc); //modal

	/*
	char msg[110];
	sprintf(msg,"Edit val=%d",g_retValue);
	MessageBox(0,msg,"x",0);
	*/

	return g_retValue;
}

// This is the message loop
BOOL CALLBACK MyProc(HWND hWnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{

	/*
		WM_COMMAND
		wNotifyCode = HIWORD(wParam); // notification code
		wID = LOWORD(wParam);         // item, control, or accelerator identifier
		hwndCtl = (HWND) lParam;      // handle of control

		EN_CHANGE
		idEditCtrl = (int) LOWORD(wParam); // identifier of edit control
		hwndEditCtrl = (HWND) lParam;      // handle of edit control

		With this you can respond to EN_CHANGE and copy the text of the edit box with
		GetWindowText(). If you just want the current line send the control a EM_GETLINE
		message.
	*/

	char buf [200];
	int hexValue=0;

	switch(uMsg)
	{
		case WM_COMMAND:
			switch(LOWORD(wParam))
			{
				case 1001: //OK button ID
					
					GetWindowText(g_hwndEditCtrl,buf,10);
					sscanf(buf,"%x", &hexValue);
					g_retValue = hexValue;
						
					EndDialog(hWnd,0);
					break;

				case 1002: //Edit control ID

				    //this happens right away because it gets focus by default
					if (g_hwndEditCtrl==0){ 
						g_hwndEditCtrl = (HWND) lParam;		
						sprintf(buf,"%x",g_retValue);
						SetWindowText(g_hwndEditCtrl, buf);
					}
			 
					break;

			}
			break;

		case WM_CLOSE:
			EndDialog(hWnd,0);
			break;

	}

	return FALSE;

}

